diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index f7cfc2be5..eb7b965d0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -10,6 +10,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T>
@@ -21,7 +22,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T>
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
     	int id = world.getBlockId(blockX, blockY, blockZ);
     	int meta = world.getBlockMetadata(blockX, blockY, blockZ) & 0x3;
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
index ac0240994..de1239de8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
@@ -14,6 +14,7 @@ import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -34,7 +35,7 @@ public class ItemToolHoe extends ItemTool
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
         return till(itemstack, player, world, blockX, blockY, blockZ, side);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index 37de18a58..192dccf15 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -12,6 +12,7 @@ import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -30,7 +31,7 @@ public class ItemToolShovel extends ItemTool
     }
 
     @Override
-    public boolean onUseItemOnBlock(ItemStack itemstack, Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean onUseItemOnBlock(@NotNull ItemStack itemstack, @Nullable Player player, @NotNull World world, int blockX, int blockY, int blockZ, @NotNull Side side, double xPlaced, double yPlaced)
     {
         return shovelBlock(itemstack, player, world, blockX, blockY, blockZ, side);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java
similarity index 98%
rename from game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java
rename to game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java
index 49f5ca96a..b16f9178b 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSpawnParticle.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java
@@ -19,11 +19,11 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.List;
 
-public class CommandSpawnParticle implements CommandManager.CommandRegistry {
+public class CommandParticle implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
-                LiteralArgumentBuilder.<CommandSource>literal("spawnparticle")
+                LiteralArgumentBuilder.<CommandSource>literal("particle")
                     .requires(CommandSource::hasAdmin)
                     .then(RequiredArgumentBuilder.<CommandSource, String>argument("particleId", ArgumentTypeParticleId.particleId())
                         .executes(c -> {
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java
index 2a04fb891..688187e45 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerAction.java
@@ -16,6 +16,7 @@ public class PacketPlayerAction extends Packet
     public static final int ACTION_DROP_ITEM_SINGLE = 4;
     public static final int ACTION_DROP_ITEM_STACK = 5;
     public static final int ACTION_PICK_BLOCK = 6;
+    public static final int ACTION_PICK_BLOCK_FULLY = 7;
 
     public int xPosition;
     public int yPosition;
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
index ce0350e51..926eeecc7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkLoaderRegion.java
@@ -54,9 +54,11 @@ public class ChunkLoaderRegion
         if(!chunk.isAtLocation(x, z))
         {
             LOGGER.warn("Chunk file at {},{} is in the wrong location; relocating. (Expected {}, {}, got {}, {})", x, z, x, z, chunk.xPosition, chunk.zPosition);
-            tag.putInt("xPos", x);
-            tag.putInt("zPos", z);
-            chunk = ChunkLoaderLegacy.loadChunkIntoWorldFromCompound(world, tag.getCompound("Level"));
+            final CompoundTag level = tag.getCompound("Level");
+            level.putInt("xPos", x);
+            level.putInt("zPos", z);
+            chunk = ChunkLoaderLegacy.loadChunkIntoWorldFromCompound(world, level);
+            assert chunk.isAtLocation(x, z);
         }
         chunk.fixMissingBlocks();
         return chunk;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureCherryTreeFancy.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureCherryTreeFancy.java
new file mode 100644
index 000000000..12d6be534
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureCherryTreeFancy.java
@@ -0,0 +1,428 @@
+package net.minecraft.core.world.generate.feature.tree;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+
+import java.util.Random;
+
+public class WorldFeatureCherryTreeFancy extends WorldFeature {
+    protected int leavesID;
+    protected int logID;
+
+    static final byte[] axisConversionArray = { 2, 0, 0, 1, 2, 1 };
+    Random rnd;
+    World world;
+    int[] origin = { 0, 0, 0 };
+    int height;
+    int trunkHeight;
+    double trunkHeightScale;
+    double branchDensity;
+    double branchSlope;
+    double widthScale;
+    double foliageDensity;
+    int trunkWidth;
+    int heightVariance;
+    int foliageHeight;
+    int[][] foliageCoords;
+    int heightMod;
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID"})
+    public WorldFeatureCherryTreeFancy(int leavesID, int logID)
+    {
+        this(leavesID, logID, 0);
+    }
+
+    @MethodParametersAnnotation(names = {"leavesID", "logID", "heightMod"})
+    public WorldFeatureCherryTreeFancy(int leavesID, int logID, int heightMod)
+    {
+        rnd = new Random();
+        height = 0;
+        trunkHeightScale = 0.6D;
+        branchDensity = 1.0D;
+        branchSlope = 0.4D;
+        widthScale = 1.0D;
+        foliageDensity = 1.0D;
+        trunkWidth = 1;
+        heightVariance = 12;
+        foliageHeight = 4;
+        this.leavesID = leavesID;
+        this.logID = logID;
+        this.heightMod = heightMod;
+    }
+
+    void prepare()
+    {
+        trunkHeight = (int)((double) height * trunkHeightScale);
+        if (trunkHeight >= height)
+        {
+            trunkHeight = height - 1;
+        }
+        int numOfClustersPerY = (int)(1.4D + Math.pow((foliageDensity * (double) height) / 13D, 2D));
+        if (numOfClustersPerY < 1)
+        {
+            numOfClustersPerY = 1;
+        }
+        int[][] foliageCoords = new int[numOfClustersPerY * height][4];
+        int yEnd = (origin[1] + height) - foliageHeight;
+        int foliageCoordsIndex = 1;
+        int topY = origin[1] + trunkHeight;
+        int y = yEnd - origin[1];
+        foliageCoords[0][0] = origin[0];
+        foliageCoords[0][1] = yEnd;
+        foliageCoords[0][2] = origin[2];
+        foliageCoords[0][3] = topY;
+        yEnd--;
+        while (y >= 0) {
+            float shapeFac = shapeFunc(y);
+            if (shapeFac < 0.0F) {
+                yEnd--;
+                y--;
+            } else {
+                double offset = 0.5D;
+                for (int i = 0; i < numOfClustersPerY; i++) {
+                    double r = widthScale * ((double)shapeFac * ((double) rnd.nextFloat() + 0.328D));
+                    double theta = (double) rnd.nextFloat() * 2D * Math.PI;
+                    int x = MathHelper.floor(r * Math.sin(theta) + (double) origin[0] + offset);
+                    int z = MathHelper.floor(r * Math.cos(theta) + (double) origin[2] + offset);
+                    int[] branchEnd = { x, yEnd, z };
+                    int[] branchTopOfTree = { x, yEnd + foliageHeight, z };
+                    if (distToMat(branchEnd, branchTopOfTree) != -1) {
+                        continue;
+                    }
+                    int[] branchStart = { origin[0], origin[1], origin[2] };
+                    double dist = Math.sqrt(Math.pow(Math.abs(origin[0] - branchEnd[0]), 2D) + Math.pow(Math.abs(origin[2] - branchEnd[2]), 2D));
+                    if ((double)branchEnd[1] - dist * branchSlope > (double)topY) {
+                        branchStart[1] = topY;
+                    }
+                    else {
+                        branchStart[1] = (int)((double)branchEnd[1] - dist * branchSlope);
+                    }
+                    if(distToMat(branchStart, branchEnd) == -1) {
+                        foliageCoords[foliageCoordsIndex][0] = x;
+                        foliageCoords[foliageCoordsIndex][1] = yEnd;
+                        foliageCoords[foliageCoordsIndex][2] = z;
+                        foliageCoords[foliageCoordsIndex][3] = branchStart[1];
+                        foliageCoordsIndex++;
+                    }
+                }
+
+                yEnd--;
+                y--;
+            }
+        }
+        this.foliageCoords = new int[foliageCoordsIndex][4];
+        System.arraycopy(foliageCoords, 0, this.foliageCoords, 0, foliageCoordsIndex);
+    }
+
+    void crossSection(int x, int y, int z, float radius, int blockId, Random random)
+    {
+        int rad = (int)(radius + 0.618D);
+
+        int[] center = { x, y, z };
+        int[] coord = { 0, 0, 0 };
+
+        coord[1] = center[1];
+        for(int off1 = -rad; off1 <= rad; off1++)
+        {
+            coord[0] = center[0] + off1;
+
+            for(int off2 = -rad; off2 <= rad; off2++)
+            {
+                coord[2] = center[2] + off2;
+
+                double thisDist = Math.sqrt(Math.pow((double) Math.abs(off1) + 0.5D, 2D) + Math.pow((double) Math.abs(off2) + 0.5D, 2D));
+                if(thisDist <= (double)radius)
+                {
+                    int id = world.getBlockId(coord[0], coord[1], coord[2]);
+                    if (id == 0 || id == leavesID || id == Blocks.LEAVES_CHERRY_FLOWERING.id())
+                    {
+                        world.setBlockWithNotify(coord[0], coord[1], coord[2], random.nextInt(5) == 0 ? Blocks.LEAVES_CHERRY_FLOWERING.id() : blockId);
+                    }
+                }
+            }
+        }
+    }
+
+    float shapeFunc(int y)
+    {
+        if (y < height * 0.3D)
+        {
+            return -1.618F;
+        }
+        float radius = height / 2.0F;
+        float adj = height / 2.0F - y;
+        float dist;
+        if (adj == 0.0F) {
+            dist = radius;
+        } else if (java.lang.Math.abs(adj) >= radius) {
+            dist = 0.0F;
+        } else {
+            dist = (float) Math.sqrt(Math.pow(Math.abs(radius), 2D) - Math.pow(Math.abs(adj), 2D));
+        }
+        dist *= 0.5F;
+        return dist;
+    }
+
+    float getFoliageShape(int y)
+    {
+        if(y < 0 || y >= foliageHeight)
+        {
+            return -1F;
+        }
+        else if (y == 0 || y == foliageHeight - 1)
+        {
+            return 2F;
+        }
+        else
+        {
+            return 3F;
+        }
+    }
+
+    void foliageCluster(int x, int y, int z, Random random)
+    {
+        for(int leavesY = y; leavesY < y + foliageHeight; leavesY++)
+        {
+            float radius = getFoliageShape(leavesY - y);
+            crossSection(x, leavesY, z, radius, leavesID, random);
+        }
+    }
+
+    void makeFoliage(Random random)
+    {
+        for (int[] foliageCoord : foliageCoords)
+        {
+            int x = foliageCoord[0];
+            int y = foliageCoord[1];
+            int z = foliageCoord[2];
+            foliageCluster(x, y, z, random);
+        }
+    }
+
+    void makeBranch(int[] startPos, int[] endPos, int blockId)
+    {
+        int[] dimensions = { 0, 0, 0 };
+        int dim0 = 0;
+
+        // Find widest dimension and assign it to dim0
+        for(int i = 0; i < 3; i++)
+        {
+            dimensions[i] = endPos[i] - startPos[i];
+            if(Math.abs(dimensions[i]) > Math.abs(dimensions[dim0]))
+            {
+                dim0 = i;
+            }
+        }
+
+        if(dimensions[dim0] == 0)
+        {
+            return;
+        }
+
+        // Look up other two dimensions
+        byte dim1 = axisConversionArray[dim0];
+        byte dim2 = axisConversionArray[dim0 + 3];
+
+        byte delta;
+        if(dimensions[dim0] > 0)
+        {
+            delta = 1;
+        }
+        else
+        {
+            delta = -1;
+        }
+
+        // Determine delta scale for other two dimensions
+        double dim1DeltaScale = (double)dimensions[dim1] / (double)dimensions[dim0];
+        double dim2DeltaScale = (double)dimensions[dim2] / (double)dimensions[dim0];
+
+        // Draw line from startPos to endPos
+        for(int i = 0; i != dimensions[dim0] + delta; i += delta)
+        {
+            int[] pos = { 0, 0, 0 };
+            pos[dim0] = MathHelper.floor((double)startPos[dim0] + (double)i + 0.5D);
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)i * dim1DeltaScale + 0.5D);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)i * dim2DeltaScale + 0.5D);
+            world.setBlockWithNotify(pos[0], pos[1], pos[2], blockId);
+        }
+    }
+
+    boolean isHighEnoughToBranch(int i)
+    {
+        return (double)i >= (double) height * 0.2D;
+    }
+
+    void makeTrunk()
+    {
+        int x = origin[0];
+        int minY = origin[1];
+        int maxY = origin[1] + trunkHeight;
+        int z = origin[2];
+        int[] startPos = { x, minY, z };
+        int[] endPos = { x, maxY, z };
+        makeBranch(startPos, endPos, logID);
+        if(trunkWidth == 2)
+        {
+            startPos[0]++;
+            endPos[0]++;
+            makeBranch(startPos, endPos, logID);
+            startPos[2]++;
+            endPos[2]++;
+            makeBranch(startPos, endPos, logID);
+            startPos[0]--;
+            endPos[0]--;
+            makeBranch(startPos, endPos, logID);
+        }
+    }
+
+    void makeBranches()
+    {
+        int[] startPos = { origin[0], origin[1], origin[2] };
+        for (int[] branchPoint : foliageCoords)
+        {
+            int[] endPos = { branchPoint[0], branchPoint[1], branchPoint[2] };
+            startPos[1] = branchPoint[3];
+            int dy = startPos[1] - origin[1];
+            if (isHighEnoughToBranch(dy))
+            {
+                makeBranch(startPos, endPos, logID);
+            }
+        }
+    }
+
+    int distToMat(int[] startPos, int[] endPos)
+    {
+        int[] dimensions = { 0, 0, 0 };
+        int dim0 = 0;
+
+        // Find widest dimension and assign it to dim0
+        for(byte i = 0; i < 3; i++)
+        {
+            dimensions[i] = endPos[i] - startPos[i];
+            if(Math.abs(dimensions[i]) > Math.abs(dimensions[dim0]))
+            {
+                dim0 = i;
+            }
+        }
+
+        if(dimensions[dim0] == 0)
+        {
+            return -1;
+        }
+
+        // Look up other two dimensions
+        byte dim1 = axisConversionArray[dim0];
+        byte dim2 = axisConversionArray[dim0 + 3];
+
+        byte delta;
+        if(dimensions[dim0] > 0)
+        {
+            delta = 1;
+        }
+        else
+        {
+            delta = -1;
+        }
+
+        // Determine delta scale for other two dimensions
+        double dim1DeltaScale = (double)dimensions[dim1] / (double)dimensions[dim0];
+        double dim2DeltaScale = (double)dimensions[dim2] / (double)dimensions[dim0];
+
+        // Check all blocks from startPos to endPos, breaking if interrupted
+        int linePos = 0;
+        int lineLength = dimensions[dim0] + delta;
+        while (linePos != lineLength)
+        {
+            int[] pos = { 0, 0, 0 };
+            pos[dim0] = startPos[dim0] + linePos;
+            pos[dim1] = MathHelper.floor((double)startPos[dim1] + (double)linePos * dim1DeltaScale);
+            pos[dim2] = MathHelper.floor((double)startPos[dim2] + (double)linePos * dim2DeltaScale);
+            int idAtPos = world.getBlockId(pos[0], pos[1], pos[2]);
+            if(idAtPos != 0 && idAtPos != leavesID && idAtPos != Blocks.LEAVES_CHERRY_FLOWERING.id())
+            {
+                break;
+            }
+            linePos += delta;
+        }
+
+        // Check if was interrupted; if so, return the distance we travelled, otherwise return -1
+        if(linePos == lineLength)
+        {
+            return -1;
+        }
+        else
+        {
+            return Math.abs(linePos);
+        }
+    }
+
+    boolean canGenerateTree()
+    {
+        int[] bottomPos = { origin[0], origin[1], origin[2] };
+        int[] topPos = { origin[0], (origin[1] + height) - 1, origin[2] };
+        int blockIdUnderneath = world.getBlockId(origin[0], origin[1] - 1, origin[2]);
+        if(!Blocks.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
+        {
+            return false;
+        }
+        int interruptedTrunkHeight = distToMat(bottomPos, topPos);
+        if(interruptedTrunkHeight == -1)
+        {
+            return true;
+        }
+        if(interruptedTrunkHeight < 6)
+        {
+            return false;
+        }
+        else
+        {
+            height = interruptedTrunkHeight;
+            return true;
+        }
+    }
+
+    @Override
+    public void init(double d, double d1, double d2)
+    {
+        heightVariance = (int)(d * (12D + heightMod));
+        if(d > 0.5D)
+        {
+            foliageHeight = 5;
+        }
+        widthScale = d1;
+        foliageDensity = d2;
+    }
+
+    @Override
+    public boolean place(World world, Random random, int x, int y, int z)
+    {
+        this.world = world;
+        long seed = random.nextLong();
+        rnd.setSeed(seed);
+        origin[0] = x;
+        origin[1] = y;
+        origin[2] = z;
+        if(height == 0)
+        {
+            height = 5 + rnd.nextInt(heightVariance);
+        }
+        if(canGenerateTree())
+        {
+            WorldFeatureTree.onTreeGrown(this.world, origin[0], origin[1], origin[2]);
+            prepare();
+            makeFoliage(random);
+            makeTrunk();
+            makeBranches();
+            return true;
+        }
+        else
+        {
+            return false;
+        }
+    }
+}
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 74cfb7f12..86f765de1 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -189,10 +189,16 @@ gui.options.page.general.category.gameplay=Gameplay
 gui.options.page.general.category.user_interface=User Interface
 gui.options.page.general.category.miscellaneous=Miscellaneous
 
+gui.options.page.player.title=Player
+gui.options.page.player.category.player=Player
+
 gui.options.page.audio.title=Audio
 gui.options.page.audio.category.audio=Audio
 gui.options.page.audio.category.debug=Debug
 
+gui.options.page.accessibility.title=Accessibility
+gui.options.page.accessibility.category.accessibility=Accessibility
+
 gui.options.page.video.title=Video
 gui.options.page.video.category.graphics=Graphics
 gui.options.page.video.category.performance=Performance
diff --git a/game/core/src/main/resources/lang/en_US/options.lang b/game/core/src/main/resources/lang/en_US/options.lang
index 3d4a4d255..228964dca 100644
--- a/game/core/src/main/resources/lang/en_US/options.lang
+++ b/game/core/src/main/resources/lang/en_US/options.lang
@@ -174,6 +174,10 @@ options.developerMode=Developer Mode
 options.forceOnscreenKeyboard=Force On Screen Keyboard
 options.enableHolidayTextures=Enable Holiday Textures
 options.dynamicCursor=Dynamic Cursor
+options.enableDevResourceLoading=Developer Resource Loading
+
+options.fov.modification=Contextual FOV Modification
+options.screen.motion.effects=Screen Motion Effects
 
 options.tooltipStyle.default=Default
 options.tooltipStyle.modern=Modern
@@ -192,7 +196,14 @@ options.tooltipStyle.redstone_goggles=Redstone Goggles
 options.tooltipStyle.creep-o-vision=Creep-o-Vision
 options.tooltipStyle.steve=Steve
 
-options.playerLeftHanded=Left Handed
+options.player.left.handed=Left Handed
+options.player.cape=Cape
+options.player.hat=Hat
+options.player.jacket=Jacket
+options.player.sleeve.left=Left Sleeve
+options.player.sleeve.right=Right Sleeve
+options.player.pant.left=Left Pant Leg
+options.player.pant.right=Right Pant Leg
 
 key.attack=Attack
 key.interact=Interact
@@ -261,4 +272,5 @@ key.debug.iteminfo=Show extra item info
 key.debug.reloadchunks=Reload chunks
 key.debug.smoothlighting=Toggle smooth lighting
 key.debug.releasecursor=Release Cursor
-key.debug.shortcuts=Show keyboard shortcuts
\ No newline at end of file
+key.debug.shortcuts=Show keyboard shortcuts
+key.debug.loadChunksQuickly=Load Chunks Quickly
\ No newline at end of file
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 0a37607a5..9e6ac56f8 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -43,7 +43,7 @@ import net.minecraft.core.net.command.commands.CommandSeed;
 import net.minecraft.core.net.command.commands.CommandSetBlock;
 import net.minecraft.core.net.command.commands.CommandSetSpawn;
 import net.minecraft.core.net.command.commands.CommandSpawn;
-import net.minecraft.core.net.command.commands.CommandSpawnParticle;
+import net.minecraft.core.net.command.commands.CommandParticle;
 import net.minecraft.core.net.command.commands.CommandSummon;
 import net.minecraft.core.net.command.commands.CommandTeleport;
 import net.minecraft.core.net.command.commands.CommandTellRaw;
@@ -418,7 +418,7 @@ public class MinecraftServer
         CommandManager.registerCommand(new CommandHeal());
         CommandManager.registerCommand(new CommandMobSpawning());
         CommandManager.registerCommand(new CommandPlaySound());
-        CommandManager.registerCommand(new CommandSpawnParticle());
+        CommandManager.registerCommand(new CommandParticle());
 
         CommandManager.registerServerCommand(new CommandStop());
         CommandManager.registerServerCommand(new CommandOp());
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index a0a111915..f65d39a62 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -113,9 +113,11 @@ public class PacketHandlerServer extends PacketHandler
 
     @Override
     public void handlePlayerConfig(PacketPlayerConfig packetPlayerConfig) {
-        playerEntity.playerConfig.config = packetPlayerConfig.config;
-        packetPlayerConfig.entityId = playerEntity.id;
-        mcServer.playerList.sendPacketToAllPlayersInDimension(packetPlayerConfig, playerEntity.dimension);
+        if (playerEntity.playerConfig.config != packetPlayerConfig.config) {
+            playerEntity.playerConfig.config = packetPlayerConfig.config;
+            packetPlayerConfig.entityId = playerEntity.id;
+            mcServer.playerList.sendPacketToAllPlayersInDimension(packetPlayerConfig, playerEntity.dimension);
+        }
     }
 
     @Override
@@ -319,18 +321,23 @@ public class PacketHandlerServer extends PacketHandler
 
         if (!canInteract() || playerEntity.getHeldObject() != null /*Forbid digging while holding object*/) return;
         WorldServer world = mcServer.getDimensionWorld(playerEntity.dimension);
-        if(playerActionPacket.action == PacketPlayerAction.ACTION_DROP_ITEM_SINGLE) {
-            // Drop single item
-            playerEntity.dropCurrentItem(false);
-            return;
-        }else if(playerActionPacket.action == PacketPlayerAction.ACTION_DROP_ITEM_STACK) {
-            // Drop full stack
-            playerEntity.dropCurrentItem(true);
-            return;
-        }else if(playerActionPacket.action == PacketPlayerAction.ACTION_PICK_BLOCK) {
-            // Pick Block
-            playerEntity.pickBlock(x, y, z);
-            return;
+        switch (playerActionPacket.action) {
+            case PacketPlayerAction.ACTION_DROP_ITEM_SINGLE:
+                // Drop single item
+                playerEntity.dropCurrentItem(false);
+                return;
+            case PacketPlayerAction.ACTION_DROP_ITEM_STACK:
+                // Drop full stack
+                playerEntity.dropCurrentItem(true);
+                return;
+            case PacketPlayerAction.ACTION_PICK_BLOCK:
+                // Pick Block
+                playerEntity.pickBlock(x, y, z, false);
+                return;
+            case PacketPlayerAction.ACTION_PICK_BLOCK_FULLY:
+                // Pick Block Fully
+                playerEntity.pickBlock(x, y, z, true);
+                return;
         }
 
         // Check player distance
